/*
 * sut is generated from model  : {{ model_file }}
 */

package sut;

import java.util.ArrayList;
import java.util.List;
import util.Parameter;
import util.Action;
import util.InputAction;
import util.OutputAction;



public class Sut {
    // Initialize statemachine variables and locations
    {% for name in statevars -%}
    int {{ name  }} = {{ statevars[name][1] }};
    {% endfor %}

    public enum Location {
        {% for location in locations -%}
        {{ location  }},
        {% endfor -%}
        ERR
    }

    private Location currentLoc = Location.{{initlocation}};


    public void reset() {
        {% for name in statevars -%}
        {{ name  }} = {{ statevars[name][1] }};
        {% endfor -%}
        currentLoc = Location.{{initlocation}};
    }

    public Location getCurrentLocation() {
        return currentLoc;
    }


    //Inputs
    {% for input in inputInterfaces -%}
    public void {{input}}( {% for paramtype in inputInterfaces[input] %} {{paramtype}} tomte_p{{ loop.index0 }} {%- if not loop.last -%}, {%- endif %} {% endfor %} ) {
        switch (currentLoc) {
        {% for location in locations -%}
        {%- set transitions=input_with_location2guard_with_action_with_target[input][location]  -%}
        {%- if  transitions %}
            case {{ location  }}:
                {% for transition in transitions -%}
                    {%- if transition['guard'] -%}
                        if ( {{ transition['guard'] }} ) {
                            {%- for action_statement in transition['action_statements'] %}
                            {{action_statement}};
                            {%- endfor %}
                            currentLoc = Location.{{ transition['target'] }};
                            break;
                        }
                    {%else -%}
                        {%- for action_statement in transition['action_statements'] %}
                        {{action_statement}};
                        {%- endfor %}
                        currentLoc = Location.{{ transition['target'] }};
                        break;
                    {%endif -%}
                {%- endfor -%}

        {%- endif -%}
        {%- endfor %}
        default:
        }
    }
    {% endfor %}


    //Outputs
    public OutputAction delta() {
        int paramIndex = 0;
        String methodName = "Oquiescence";
        List < Parameter > result = new ArrayList < Parameter > ();
        switch (currentLoc) {
        {% for location in locations -%}
        {%- set transitions=location2guard_with_action_with_output_with_target[location]  -%}
        {%- if  transitions %}
            case {{ location  }}:
                {% for transition in transitions -%}
                    {%- if transition['guard'] -%}
                        if ( {{ transition['guard'] }} ) {
                            {%- for action_statement in transition['action_statements'] %}
                            {{action_statement}};
                            {%- endfor %}
                            methodName = "{{ transition['output_event'] }}";
                            {%- for param in transition['output_event_params'] %}
                            result.add(new Parameter({{ param }}, paramIndex));
                            {%- endfor %}
                            currentLoc = Location.{{ transition['target'] }};
                            break;
                        }
                    {%else -%}
                        {%- for action_statement in transition['action_statements'] %}
                        {{action_statement}};
                        {%- endfor %}
                        methodName = "{{ transition['output_event'] }}";
                        {%- for param in transition['output_event_params'] %}
                        result.add(new Parameter({{ param }}, paramIndex));
                        {%- endfor %}
                        currentLoc = Location.{{ transition['target'] }};
                        break;
                    {%endif -%}
                {%- endfor -%}

        {%- endif -%}
        {%- endfor %}
        default:
        }
        return new OutputAction(methodName, result);
    }


    public OutputAction processSymbol(InputAction methodWrapper) {
        {% for input in inputInterfaces -%}
        if (methodWrapper.getMethodName().equals("{{input}}")) {
            List < Parameter > params = methodWrapper.getParameters();
            {{input}}(
            {%- for paramtype in inputInterfaces[input] -%}
               (params.get( {{- loop.index0 -}} ).getValue())
               {%- if not loop.last -%}, {%- endif %}
            {%- endfor -%}
            );
            return delta();
        }
        {% endfor %}
        return null;
    }



}